// -------------------------------------------------------
// This file is part of the OpenNETCF.Telephony Library
// 2007-2009 OpenNETCF Consulting, LLC
// www.opennetcf.com
//
// For license information visit http://tapi.codeplex.com
// -------------------------------------------------------

using System;
using System.Runtime.InteropServices;

namespace OpenNETCF.Telephony
{
    [StructLayout(LayoutKind.Sequential)]
    internal class AddressCapabilities : PhoneBase
    {
        public AddressCapabilities(int size)
            : base(size)
        {
            dwTotalSize = Data.Length; ;
        }
        protected override int MinimumSize { get { return 1024; } }
        public int dwTotalSize;
        public int dwNeededSize;
        public int dwUsedSize;
        public int dwLineDeviceID;
        public int dwAddressSize;
        public int dwAddressOffset;
        public int dwDevSpecificSize;
        public int dwDevSpecificOffset;
        public int dwAddressSharing;
        public int dwAddressStates;
        public CallInfoState dwCallInfoStates;
        public int dwCallerIDFlags;
        public int dwCalledIDFlags;
        public int dwConnectedIDFlags;
        public int dwRedirectionIDFlags;
        public int dwRedirectingIDFlags;
        public CallState dwCallStates;
        public int dwDialToneModes;
        public int dwBusyModes;
        public int dwSpecialInfo;
        public DisconnectMode dwDisconnectModes;
        public int dwMaxNumActiveCalls;
        public int dwMaxNumOnHoldCalls;
        public int dwMaxNumOnHoldPendingCalls;
        public int dwMaxNumConference;
        public int dwMaxNumTransConf;
        public int dwAddrCapFlags;
        public int dwCallFeatures;
        public int dwRemoveFromConfCaps;
        public int dwRemoveFromConfState;
        public int dwTransferModes;
        public int dwParkModes;
        public ForwardMode dwForwardModes;
        public int dwMaxForwardEntries;
        public int dwMaxSpecificEntries;
        public int dwMinFwdNumRings;
        public int dwMaxFwdNumRings;
        public int dwMaxCallCompletions;
        public int dwCallCompletionConds;
        public int dwCallCompletionModes;
        public int dwNumCompletionMessages;
        public int dwCompletionMsgTextEntrySize;
        public int dwCompletionMsgTextSize;
        public int dwCompletionMsgTextOffset;

        public int dwAddressFeatures;                              // TAPI v1.4

        public int dwPredictiveAutoTransferStates;                 // TAPI v2.0
        public int dwNumCallTreatments;                            // TAPI v2.0
        public int dwCallTreatmentListSize;                        // TAPI v2.0
        public int dwCallTreatmentListOffset;                      // TAPI v2.0
        public int dwDeviceClassesSize;                            // TAPI v2.0
        public int dwDeviceClassesOffset;                          // TAPI v2.0
        public int dwMaxCallDataSize;                              // TAPI v2.0
        public int dwCallFeatures2;                                // TAPI v2.0
        public int dwMaxNoAnswerTimeout;                           // TAPI v2.0
        public int dwConnectedModes;                               // TAPI v2.0
        public int dwOfferingModes;                                // TAPI v2.0
        public int dwAvailableMediaModes;                          // TAPI v2.0

    }
}
