// -------------------------------------------------------
// This file is part of the OpenNETCF.Telephony Library
// 2007-2009 OpenNETCF Consulting, LLC
// www.opennetcf.com
//
// For license information visit http://tapi.codeplex.com
// -------------------------------------------------------

using System;

namespace OpenNETCF.Telephony
{
    /// <summary>
    /// TAPI Exception
    /// </summary>
    public class TelephonyException : Exception
    {
        private string m_message;
        
        /// <summary>
        /// TAPI error code
        /// </summary>
        public int NativeError;

        /// <summary>
        /// Create an instance of TelephonyException with the supplied TAPI error code
        /// </summary>
        public TelephonyException(int err)
        {
            NativeError = err;
        }

        /// <summary>
        /// Create an instance of TelephonyException with the supplied TAPI error code and error message
        /// </summary>
        public TelephonyException(string message, int err)
        {
            NativeError = err;
            m_message = message;
        }

        /// <summary>
        /// Retrieves the error message
        /// </summary>
        public override string Message
        {
            get { return string.Format("{0} {1}", m_message, ((ErrorCode) NativeError)); }
        }
    }
}